

.386
.model flat,stdcall
option casemap:none

include windows.inc
include \masm32\include\masm32.inc
include user32.inc
include kernel32.inc
include gdi32.inc
include shell32.inc

includelib \masm32\lib\masm32.lib
includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib shell32.lib

include ComboX.inc

DllEntry 		PROTO :DWORD,:DWORD,:DWORD

NewControlProc	PROTO :DWORD,:DWORD,:DWORD,:DWORD
NewEditProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data?	
hInstance dd ?		
COMBODATA struct
	hwndEdit		dd 0
	oldWndProc		dd 0
	fPushed 		dd 0
	fAllowPush		dd 0
	rcBtn			RECT <>
COMBODATA ends

.data
szEditClass		db "Edit",0

.code

MAKEDWORD macro LoWord,HiWord
          mov ax, HiWord
          ror eax, 16
          mov ax, LoWord
endm
LOWORD macro bigword  
       mov  eax,bigword
       and  eax,0FFFFh      
endm
HIWORD macro bigword  
       mov  eax,bigword
       shr  eax,16
endm       
DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
    push hInst
    pop  hInstance                                       
	.if reason==DLL_PROCESS_ATTACH
	    
	.elseif reason==DLL_PROCESS_DETACH
        
        xor eax,eax 
	.endif
	mov  eax,TRUE
	ret
DllEntry endp
CreateComboX proc dwExStyle:DWORD,lpClassName:LPSTR,lpWindowName:LPSTR,dwStyle:DWORD,x:DWORD,y:DWORD,nWidth:DWORD,nHeight:DWORD,hWndParent:HWND,hMenu:HMENU,hInst:HINSTANCE,lParam:LPARAM
	LOCAL hCombo	:DWORD
    LOCAL rcCmb		:RECT
    LOCAL cmbStyle	:DWORD
    
	.if (dwExStyle & WS_EX_CLIENTEDGE)
    	invoke CreateWindowEx,0,lpClassName,\
    			lpWindowName,dwStyle,x,y,nWidth,nHeight,\
    			hWndParent,hMenu,hInst,NULL
    	ret
	.endif
	push ebx
	ASSUME ebx:PTR COMBODATA
    mov eax,dwStyle
    and eax,CBS_DROPDOWNLIST
    mov cmbStyle,eax
    .if eax==CBS_SIMPLE
    	invoke CreateWindowEx,0,lpClassName,\
    			lpWindowName,dwStyle,x,y,nWidth,nHeight,\
    			hWndParent,hMenu,hInst,NULL
    	mov hCombo,eax
    	jmp finish
    .elseif eax==CBS_DROPDOWN 
    	invoke CreateWindowEx,0,lpClassName,\
    			lpWindowName,dwStyle,x,y,nWidth,nHeight,\
    			hWndParent,hMenu,hInst,NULL
    	mov hCombo,eax
    .elseif eax==CBS_DROPDOWNLIST
    	btr dwStyle,0
    	invoke CreateWindowEx,0,lpClassName,\
    			lpWindowName,dwStyle,x,y,nWidth,nHeight,\
    			hWndParent,hMenu,hInst,NULL
    	mov hCombo,eax
    .endif
	invoke GetProcessHeap
	invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,sizeof COMBODATA
	mov ebx,eax
    invoke FindWindowEx,hCombo,NULL,addr szEditClass,NULL
    mov [ebx].hwndEdit,eax
	.if cmbStyle==CBS_DROPDOWNLIST
		invoke SetWindowLong,[ebx].hwndEdit,GWL_WNDPROC,addr NewEditProc
		invoke SetWindowLong,[ebx].hwndEdit,GWL_USERDATA,eax	
	.endif
	invoke SetWindowLong,hCombo,GWL_WNDPROC,addr NewControlProc
	mov [ebx].oldWndProc,eax
	mov [ebx].fPushed,0
	invoke SetWindowLong,hCombo,GWL_USERDATA,ebx	
	finish:
	mov eax,hCombo
	ASSUME ebx:nothing
	pop ebx
	ret
CreateComboX endp
NewControlProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL rcEdit	:RECT
    LOCAL rcCmb		:RECT
    LOCAL oldRect	:RECT
    LOCAL pt		:POINT
	LOCAL hdc		:DWORD
	LOCAL nWidth	:DWORD
	LOCAL ps		:PAINTSTRUCT
	LOCAL rc		:RECT
	
	push ebx
	ASSUME ebx:PTR COMBODATA
	invoke GetWindowLong,hWin,GWL_USERDATA
	mov ebx,eax
	
;----------------------------------------------	
	.if uMsg==WM_PAINT
		invoke BeginPaint,hWin,addr ps
		mov hdc,eax
		.if [ebx].fPushed==TRUE
			invoke DrawFrameControl,hdc,addr [ebx].rcBtn,DFC_SCROLL,DFCS_SCROLLDOWN or DFCS_FLAT
		.else
			invoke DrawFrameControl,hdc,addr [ebx].rcBtn,DFC_SCROLL,DFCS_SCROLLDOWN
		.endif	
		invoke EndPaint,hWin,addr ps
;----------------------------------------------	
	.elseif uMsg==WM_LBUTTONDOWN
		mov [ebx].fPushed,TRUE
		mov [ebx].fAllowPush,TRUE
		invoke CallWindowProc,[ebx].oldWndProc,hWin,uMsg,wParam,lParam
    	invoke GetWindowRect,hWin,addr rcCmb
    	invoke GetTopWindow,0
    	invoke SetWindowPos,eax,NULL,rcCmb.left,rcCmb.bottom,0,0,SWP_NOSIZE or SWP_NOZORDER
		invoke InvalidateRect,hWin,NULL,FALSE
;----------------------------------------------
	.elseif uMsg==WM_MOUSEMOVE 
		.if (wParam & MK_LBUTTON)
			LOWORD lParam
			mov pt.x,eax
			HIWORD lParam
			mov pt.y,eax
    		invoke GetClientRect,hWin,addr rcCmb
    		invoke PtInRect,addr rcCmb,pt.x,pt.y
    		.if ! eax 
    			.if [ebx].fPushed
    				mov [ebx].fPushed,FALSE
					invoke InvalidateRect,hWin,NULL,FALSE
				.endif	
    		.else
    			.if [ebx].fPushed==FALSE && [ebx].fAllowPush==TRUE
    				mov [ebx].fPushed,TRUE
					invoke InvalidateRect,hWin,NULL,FALSE
				.endif	
    		.endif
		.endif
;----------------------------------------------
	.elseif uMsg==WM_CAPTURECHANGED	
		mov [ebx].fAllowPush,FALSE
;----------------------------------------------
	.elseif uMsg==WM_LBUTTONUP
		invoke CallWindowProc,[ebx].oldWndProc,hWin,uMsg,wParam,lParam
		mov [ebx].fPushed,FALSE
		invoke InvalidateRect,hWin,NULL,FALSE
;----------------------------------------------	
	.elseif uMsg==WM_WINDOWPOSCHANGED
		push edi
		ASSUME edi:PTR WINDOWPOS
		mov edi,lParam
		invoke GetClientRect,[ebx].hwndEdit,addr rcEdit
    	invoke SetWindowPos,[ebx].hwndEdit,NULL,0,0,0,0,SWP_NOZORDER or SWP_NOSIZE
		
		mov eax,rcEdit.bottom
		sub eax,rcEdit.top
    	invoke SetWindowPos,hWin,NULL,0,0,[edi].lx,eax,SWP_NOZORDER or SWP_NOMOVE
		invoke SetRect,addr [ebx].rcBtn,rcEdit.right,rcEdit.top,[edi].lx,rcEdit.bottom
		ASSUME edi:nothing
		pop edi
;----------------------------------------------	
	.elseif uMsg==WM_DESTROY
		invoke CallWindowProc,[ebx].oldWndProc,hWin,uMsg,wParam,lParam
		invoke GetProcessHeap
		invoke HeapFree,eax,0,ebx
;----------------------------------------------	
	.elseif uMsg==WM_NCDESTROY

;----------------------------------------------	
	.else
		invoke CallWindowProc,[ebx].oldWndProc,hWin,uMsg,wParam,lParam
		jmp finish
	.endif
	xor eax,eax
	finish:
	ASSUME ebx:nothing
	pop ebx
	ret
NewControlProc endp
NewEditProc proc hwnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
    .if uMsg==WM_CHAR
    
    .elseif uMsg==WM_SETFOCUS
		invoke GetWindowLong,hwnd,GWL_USERDATA
		invoke CallWindowProc,eax,hwnd,uMsg,wParam,lParam
		invoke HideCaret,hwnd
		ret
	.elseif uMsg==WM_MOUSEACTIVATE	
		mov eax,MA_NOACTIVATEANDEAT
		ret
	.else
		invoke GetWindowLong,hwnd,GWL_USERDATA
		invoke CallWindowProc,eax,hwnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
NewEditProc endp

End DllEntry
