

.386
.model flat,stdcall
option casemap:none

include windows.inc
include \masm32\include\masm32.inc
include user32.inc
include kernel32.inc
include gdi32.inc
include shell32.inc

includelib \masm32\lib\masm32.lib
includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib shell32.lib

include ComboX.inc

DllEntry 		PROTO :DWORD,:DWORD,:DWORD
ControlProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD
NewComboProc	PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data?	
hInstance dd ?		

.data
szControlClass	db "NewComboX",0
aCmbClass		ATOM 0

.code

MAKEDWORD macro LoWord,HiWord
          mov ax, HiWord
          ror eax, 16
          mov ax, LoWord
endm
LOWORD macro bigword  
       mov  eax,bigword
       and  eax,0FFFFh      
endm
HIWORD macro bigword  
       mov  eax,bigword
       shr  eax,16
endm       
DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
    push hInst
    pop  hInstance                                       
	.if reason==DLL_PROCESS_ATTACH
	    
       
	.elseif reason==DLL_PROCESS_DETACH
        
        xor eax,eax 
	.endif
	mov  eax,TRUE
	ret
DllEntry endp
InitControlClass proc hInst:HINSTANCE
	LOCAL wc	:WNDCLASSEX
	
	mov wc.cbSize,sizeof WNDCLASSEX
	mov wc.style,0
	mov wc.lpfnWndProc,offset ControlProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	push hInst
	pop wc.hInstance
	mov wc.hIcon,NULL
	invoke LoadCursor,NULL,IDC_ARROW
	mov wc.hCursor,eax
	mov wc.hbrBackground,NULL
	mov wc.lpszMenuName,NULL
	mov wc.lpszClassName,offset szControlClass
	mov wc.hIconSm,NULL
	
	invoke RegisterClassEx,addr wc
	mov aCmbClass,ax
	
	ret
InitControlClass endp
CreateComboX proc dwExStyle:DWORD,lpClassName:LPSTR,lpWindowName:LPSTR,dwStyle:DWORD,x:DWORD,y:DWORD,nWidth:DWORD,nHeight:DWORD,hWndParent:HWND,hMenu:HMENU,hInst:HINSTANCE,lParam:LPARAM
	LOCAL hCombo	:DWORD
	LOCAL hControl	:DWORD
    LOCAL rcCmb		:RECT
    LOCAL cmbStyle	:DWORD
    
    
	.if (dwExStyle & WS_EX_CLIENTEDGE)
    	invoke CreateWindowEx,0,lpClassName,\
    			lpWindowName,dwStyle,x,y,nWidth,nHeight,\
    			hWndParent,hMenu,hInst,NULL
    	ret
	.endif
    mov eax,dwStyle
    and eax,CBS_DROPDOWNLIST
    .if eax==CBS_SIMPLE
    	invoke CreateWindowEx,0,lpClassName,\
    			lpWindowName,dwStyle,x,y,nWidth,nHeight,\
    			hWndParent,hMenu,hInst,NULL
    	ret
    .endif	
	.if aCmbClass==0
		invoke InitControlClass,hInst
		mov aCmbClass,ax
	.endif	
    invoke CreateWindowEx,0,addr szControlClass,\
    			lpWindowName,WS_CHILD or WS_VISIBLE,x,y,nWidth,nHeight,\
    			hWndParent,hMenu,hInst,NULL
	mov hControl,eax
    invoke CreateWindowEx,0,lpClassName,\
    			lpWindowName,dwStyle,0,0,nWidth,nHeight,\
    			hControl,hMenu,hInst,NULL
	mov hCombo,eax
	invoke SetWindowLong,hControl,GWL_USERDATA,eax	
	invoke SetWindowLong,hCombo,GWL_WNDPROC,addr NewComboProc
	invoke SetWindowLong,hCombo,GWL_USERDATA,eax	
	invoke GetClientRect,hCombo,addr rcCmb
	mov eax,rcCmb.bottom
	sub eax,rcCmb.top
	sub eax,4
    invoke SetWindowPos,hControl,NULL,0,0,nWidth,eax,SWP_NOZORDER or SWP_NOMOVE
    mov eax,hControl
	ret
CreateComboX endp

ControlProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL rcRect	:RECT
	LOCAL nWidth	:DWORD
	LOCAL nHeight	:DWORD
	LOCAL hCombo	:DWORD
    
;---------------------------------------------------------------------		
	.if uMsg==WM_CREATE	
	
;---------------------------------------------------------------------		
	.elseif uMsg==WM_COMMAND
		invoke GetParent,hWin
		invoke SendMessage,eax,WM_COMMAND,wParam,lParam
;---------------------------------------------------------------------		
	.elseif uMsg==WM_NOTIFY
		invoke GetParent,hWin
		invoke SendMessage,eax,WM_NOTIFY,wParam,lParam
;---------------------------------------------------------------------		
	.elseif uMsg==WM_WINDOWPOSCHANGED
		push edi
		ASSUME edi:PTR WINDOWPOS
		mov edi,lParam
		invoke GetWindowLong,hWin,GWL_USERDATA
		mov ecx,[edi].lx
		mov edx,[edi].cy
		add ecx,4
		add edx,4
    	invoke SetWindowPos,eax,NULL,-2,-2,ecx,edx,SWP_NOZORDER
    
    	ASSUME edi:nothing
		pop edi
;---------------------------------------------------------------------		
    .elseif uMsg==WM_SETFONT
		invoke GetWindowLong,hWin,GWL_USERDATA
		mov hCombo,eax
		invoke SendMessage,hCombo,WM_SETFONT,wParam,TRUE
		invoke GetClientRect,hCombo,addr rcRect
		mov eax,rcRect.bottom
		sub eax,rcRect.top
		sub eax,4
		mov nHeight,eax
		invoke GetClientRect,hWin,addr rcRect
		mov eax,rcRect.right
		sub eax,rcRect.left
		mov nWidth,eax
    	invoke SetWindowPos,hWin,NULL,0,0,nWidth,nHeight,SWP_NOMOVE or SWP_NOZORDER
;---------------------------------------------------------------------		
	.elseif uMsg==WM_DESTROY
		
;---------------------------------------------------------------------		
	.elseif uMsg>=CB_GETEDITSEL && uMsg<=CB_INITSTORAGE
		invoke GetWindowLong,hWin,GWL_USERDATA
		invoke SendMessage,eax,uMsg,wParam,lParam
;---------------------------------------------------------------------		
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	finish:
	xor eax,eax
	ret
ControlProc endp
NewComboProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL rcCtl		:RECT
    LOCAL rcList	:RECT
    LOCAL hList		:DWORD
;----------------------------------------------	
	.if uMsg==WM_LBUTTONDOWN
		invoke GetWindowLong,hWin,GWL_USERDATA
		invoke CallWindowProc,eax,hWin,uMsg,wParam,lParam
		invoke GetParent,hWin
		mov edx,eax
    	invoke GetWindowRect,edx,addr rcCtl
    	invoke GetTopWindow,NULL
    	mov hList,eax
    	invoke GetWindowRect,hList,addr rcList
    	invoke InflateRect,addr rcList,-2,0
    	mov ecx,rcList.right
    	mov edx,rcList.bottom
    	sub ecx,rcList.left
    	sub edx,rcList.top
    	invoke SetWindowPos,hList,NULL,rcCtl.left,rcCtl.bottom,ecx,edx,SWP_NOZORDER
;----------------------------------------------	
	.else
		invoke GetWindowLong,hWin,GWL_USERDATA
		invoke CallWindowProc,eax,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
NewComboProc endp


End DllEntry
